# Replication material for: A Nodewise Regression Approach to Estimating Large Portfolios

# Mehmet Caner, Esra Ulasan, Laurent Callot, A. zlem nder 

Date: 12/09/2018

This repository contains the replication material for the empirical application in A Nodewise Regression Approach to Estimating Large Portfolios. All the computations are carried using *R* and the *knitr* package for easy replication. The material is divided between 4 folders:

 - **application**: contains a **knitr** file, **application.Rnw**, to be compiled to generate the tables in the paper. **Ndw.Rda** contains all empirical results in the same place. 
 - **results**: contains **XXX.Rda** files which show all results of different time periods separately.
 - **code**: contains 4 files. **roll.R** contains the code for Nodewise regression and other high dimensional covariance matrix estimators and the rolling window forecast analysis. **roll_script.R** contains the global settings for the empirical application and runs the experiments. The other two files contain constants and data generation for out-of-sample forecast. 
  - **data**: 5 files called **snp_returns_XXX.rds** contain the asset and risk free rate for 5 different time periods. 5 files called **snp_excess_XXX.rds** contain the excess returns for 5 time periods.
