#SETUP TOEPLITZ STRUCTURE, lw shrinkage. Markowitz
#Tables 2a-b, lw
library(Matrix)

library(POET)
library(MASS)
library(mvtnorm)
set.seed(10)

rho1=0.000376#daily return that corresponds to yearly return

rhoz=0.15#correlation
n=100#sample size
p=0.5*n# of assets in portfolio
mu=rnorm(p)/100
omz=diag(p)#WILL FORM SIGMA

for(j in (1:p)){
  
  for (i in (1:p)){
    omz[i,j]=(rhoz)^{abs(i-j)}}
}
iomz=solve(omz)#very sparse, precision matrix, SIGMA^{-1} OR THETA

#SETUP CONSTANTS

ones=rep(1,p)
ones=matrix(ones,p,1)

A=t(ones)%*%iomz%*%ones/p
B=t(ones)%*%iomz%*%mu/p
D=t(mu)%*%iomz%*%mu/p

w1=(D- rho1*B)/(A*D- B^2)
w1=matrix(w1,1,1)

w11=(iomz%*%ones/p)%*%w1
w2=(rho1*A - B)/(A*D - B^2)
w2=matrix(w2,1,1)
w21=(iomz%*%mu/p)%*%w2
ws=w11+w21#weight in markowitz
opv=(A*rho1^2-2*B*rho1+D)/(A*D-B^2)




#GENERATE EXCESS ASSET RETURNS


t1=matrix(0,p,p)
t2=matrix(0,p,p)
snst=matrix(0,p,p)
  
ite=100
l1e=matrix(0,ite,1)
err1=matrix(0,ite,1)
thm3er=matrix(0,ite,1)


for (jj in 1:ite)
{
  
 # rr11=rnorm(n*p)
  #rr11=matrix(rr11,n,p)
  #sqomz=chol(omz)
  #r=rr11%*%sqomz
  
  r=rmvnorm(n*p,mu,omz)
r=matrix(r,n,p)

#generated
ndmr=matrix(0,n,p)
#form sigmahat
rbar=colMeans(r)#should be p by 1
rbar=matrix(rbar,p,1)
for (t in 1:n)
{ndmr[t,]=r[t,]-t(rbar)

}
####

  
  ndmr=matrix(ndmr,n,p)
  shat=t(ndmr)%*%ndmr/n
  shat=matrix(shat,p,p)
  mn=diag(shat)
  mn=matrix(mn,p,1)
  smn=sum(mn)/p
  ###smn is mn in lw
  dmat=(shat-smn*diag(p))%*%t((shat-smn*diag(p)))
  ddmat=diag(dmat)
  ddmat=matrix(ddmat,p,1)
  dn2=sum(ddmat)/p# dn2 in LW
  kk=matrix(0,p,p)
  kk1=matrix(0,p,1)
  bn2=matrix(0,n,1)
  for (i in 1:n)
  {kk=(ndmr[i,]%*%t(ndmr[i,])- shat)%*%t(ndmr[i,]%*%t(ndmr[i,])- shat)#r TAKES ROW VECTOR MAKES IT COLUMN
  kk1=diag(kk)
  skk1=sum(kk1)/p
  bn2[i]=skk1
  }
  abn2=mean(bn2)/n # since we divide by n2
  rbn2=min(abn2,dn2)#real bn2 min of adj bn2 and dn2 in LW
  an2=dn2-rbn2#alphan2 in LW
  t1=diag(p)*smn*rbn2/dn2
  t2=shat*an2/dn2
  snst=t1+t2#snst is Sn* in LW, will replace covariance matrix odf returns
  invsnst=solve(snst)#precision matrix estimate
  
  Ahat=t(ones)%*%invsnst%*%ones/p
  
  Bhat=t(ones)%*%invsnst%*%rbar/p
  Dhat=t(rbar)%*%invsnst%*%rbar/p
  opvhat=(Ahat*rho1^2-2*Bhat*rho1+ Dhat)/(Ahat*Dhat-Bhat^2)
  
  w1hat1=matrix(0,p,1)
  w2hat2=matrix(0,p,1)
  w1hat=matrix(0,1,1)
  w2hat=matrix(0,1,1)
  w1hat=(Dhat- rho1*Bhat)/(Ahat*Dhat- Bhat^2)
  w1hat1=(invsnst%*%ones/p)%*%w1hat
  w2hat=(rho1*Ahat - Bhat)/(Ahat*Dhat - Bhat^2)
  w2hat2=(invsnst%*%rbar/p)%*%w2hat
  wshat=w1hat1+w2hat2#weight in markowitz
  aw=abs(wshat-ws)
  l1e[jj]=colSums(aw)#li error markowitz
  thm3er[jj]=abs(t(wshat)%*%(snst-omz)%*%wshat)
  
  err1[jj]=abs(opvhat/opv-1)
  print(jj)
}
  
  
  
  
  
  
  
  
print("variance error")
print(mean(err1))#thm 1 error
  

print("l1 error of weights")
print(mean(l1e))#thm 2 error
print("thm 3 error:risk")
print(mean(thm3er))



  