#SETUP TOEPLITZ STRUCTURE, lw shrinkage
#tables 1a-b. lw 
library(Matrix)
library(MASS)
rhoz=0.15#correlation
n=100#sample size
p=0.5*n# of assets in portfolio
omz=diag(p)#WILL FORM SIGMA

for(j in (1:p)){
  
  for (i in (1:p)){
    omz[i,j]=(rhoz)^{abs(i-j)}}
}
iomz=solve(omz)#very sparse, precision matrix, SIGMA^{-1} OR THETA

#SETUP CONSTANTS
ones=rep(1,p)
ones=matrix(ones,p,1)
A=t(ones)%*%iomz%*%ones
w=(iomz%*%ones)%*%A^(-1)
####



#GENERATE EXCESS ASSET RETURNS


t1=matrix(0,p,p)
t2=matrix(0,p,p)
snst=matrix(0,p,p)
  
ite=100
error=matrix(0,ite,1)
ew1=matrix(0,ite,1)
thm3er=matrix(0,ite,1)


for (jj in 1:ite)
{
  rr11=rnorm(n*p)
  rr11=matrix(rr11,n,p)
  sqomz=chol(omz)
  #t(sqomz)*sqomz=omz
  r=rr11%*%sqomz#n by p
  #generated
  ndmr=matrix(0,n,p)#nby p excess asset return demeaned
  #form sigmahat
  rbar=colMeans(r)#should be p by 1
  rbar=matrix(rbar,p,1)
  for (t in 1:n)
  {ndmr[t,]=r[t,]-t(rbar)
  
  }
  ndmr=matrix(ndmr,n,p)
  shat=t(ndmr)%*%ndmr/n
  shat=matrix(shat,p,p)
  mn=diag(shat)
  mn=matrix(mn,p,1)
  smn=sum(mn)/p
  ###smn is mn in lw
  dmat=(shat-smn*diag(p))%*%t((shat-smn*diag(p)))
  ddmat=diag(dmat)
  ddmat=matrix(ddmat,p,1)
  dn2=sum(ddmat)/p# dn2 in LW
  kk=matrix(0,p,p)
  kk1=matrix(0,p,1)
  bn2=matrix(0,n,1)
  for (i in 1:n)
  {kk=(ndmr[i,]%*%t(ndmr[i,])- shat)%*%t(ndmr[i,]%*%t(ndmr[i,])- shat)#r TAKES ROW VECTOR MAKES IT COLUMN
  kk1=diag(kk)
  skk1=sum(kk1)/p
  bn2[i]=skk1
  }
  abn2=mean(bn2)/n # since we divide by n2
  rbn2=min(abn2,dn2)#real bn2 min of adj bn2 and dn2 in LW
  an2=dn2-rbn2#alphan2 in LW
  t1=diag(p)*smn*rbn2/dn2
  t2=shat*an2/dn2
  snst=t1+t2#snst is Sn* in LW, will replace covariance matrix odf returns
  invsnst=solve(snst)#precision matrix estimate
  
  
  Ahat=t(ones)%*%invsnst%*%ones
  
  what=(invsnst%*%ones)%*%Ahat^(-1)
  errorw1=abs(what-w)
  ew1[jj]=colSums(errorw1)
  
  thm3er[jj]=t(what)%*%(snst-omz)%*%what#thm 3 error
  thm3er[jj]=abs(thm3er[jj])
  error[jj]=abs(Ahat/A-1)

  print(jj)}

print("l1 error of weights")
print(mean(ew1))#thm 2 error
print("thm 3 error:risk")
print(mean(thm3er))
print("variance error")
print(mean(error))#thm 1 error


  