#SETUP TOEPLITZ STRUCTURE, FACTOR MODEL ESTIMATION BY POET
#Tables 1a-b, POET
library(POET)
library(MASS)
rhoz=0.15#correlation
n=100#sample size
p=0.5*n# of assets in portfolio
omz=diag(p)#WILL FORM SIGMA

for(j in (1:p)){
  
  for (i in (1:p)){
    omz[i,j]=(rhoz)^{abs(i-j)}}
}
iomz=solve(omz)#very sparse, precision matrix, SIGMA^{-1} OR THETA

#GENERATE EXCESS ASSET RETURNS

ite=100
ew1=matrix(0,ite,1)
error=matrix(0,ite,1)
thm3er=matrix(0,ite,1)
for (jj in 1:ite){

  
  rr11=rnorm(n*p)
  rr11=matrix(rr11,n,p)
  sqomz=chol(omz)
  #t(sqomz)*sqomz=omz
  r=rr11%*%sqomz#n by p
  #generated
  ndmr=matrix(0,n,p)#nby p excess asset return demeaned
  #form sigmahat
  rbar=colMeans(r)#should be p by 1
  rbar=matrix(rbar,p,1)
  for (t in 1:n)
  {ndmr[t,]=r[t,]-t(rbar)
  
  }
  covY=POET(t(ndmr),7,0.5,"soft","vad")$SigmaY
  #covY are sample covariancematrix of returns by POET,0.5,SOFT,VAD ARE DEFAULTS, 
  #7 FACTORS ARE  RECOMMENDED BY POET PROGRAM,ALTERNATIVE IS ESTIMATE AND FIT
  invcov=ginv(covY)#INVERSE MATRIX PRECISION ESTIMATE
  #SETUP CONSTANTS
  ones=rep(1,p)
  ones=matrix(ones,p,1)
  A=t(ones)%*%iomz%*%ones
  w=(iomz%*%ones)%*%A^(-1)
  #####
  
  
  Ahat=t(ones)%*%invcov%*%ones
  
  what=(invcov%*%ones)%*%Ahat^(-1)
  errorw1=abs(what-w)
  ew1[jj]=colSums(errorw1)
  
  thm3er[jj]=t(what)%*%(covY-omz)%*%what#thm 3 error
  thm3er[jj]=abs(thm3er[jj])
  error[jj]=abs(Ahat/A-1)

  }

print("l1 error of weights")
print(mean(ew1))#thm 2 error
print("thm 3 error:risk")
print(mean(thm3er))
print("variance error")
print(mean(error))#thm 1 error
  
  