library(glmnet)#factor DGP-MARKOWITZ-NWISE, work on that if we want to put a factor structure mean, not error mean
#factor dgp
#Tables 4a-4b, nwise
n=100
p=1*n/2
set.seed(10)
mu=rnorm(p)/10
#mu=rnorm(p,mean=0.0005,sd=0.0008)
#mu=rep(0.0000003,p)
mu=matrix(mu,p,1)/10


rho1=0.000376#daily return that corresponds to yearly return
library(MASS)
r=matrix(0,n,p)#return matrix
ite=100
err1=matrix(0,ite,1)
l1e=matrix(0,ite,1)
thm3er=matrix(0,ite,1)

#now nodewise regression
#lambda choices
lambda1=c(10,20,30,40,50)#5 lambdas
lambda1=matrix(lambda1,length(lambda1),1)





for (jj in 1:ite){
  
  
  
  
  



for (jjj in 1:n){
muf=matrix(0,3,1)

  muf=matrix(muf,3,1)
covf=diag(3)/10
covf=matrix(covf,3,3)
f=mvrnorm(1,muf,covf)
f=matrix(f,3,1)#3-factors
##do this for each p, next steps to Get B factor loadings
mub=matrix(0,3,1)

mub=matrix(mub,3,1)
covb=diag(3)/100
covb=matrix(covb,3,3)

b=matrix(0,p,3)#factor loadings
for (i in 1:p){
#mub=rep(mu[i]/3,3)
#mub=matrix(mub,3,1)
  bi=mvrnorm(1,mub,covb)
bi=matrix(bi,1,3)
b[i,]=bi}

cov=diag(p)
sig=b%*%covf%*%t(b)+cov#Sigma var cov matrix of returns, good for any i
#so it stays
#by (1.3) of Fan and Lv 2008, JOE
mue=matrix(0,p,1)
##mu instead of mue so that Er=mu by epsilon, this is easy.
eps=mvrnorm(1,mue,cov)#p by 1 N(0, cov) where cov is gamma distributed
ret=mu+b%*%f+eps
r[jjj,]=t(ret)



}
###dgp is done
  Shat=matrix(0,p,p)
  rbar=colMeans(r)#should be p by 1
  rbar=matrix(rbar,p,1)
  ndmr=matrix(0,n,p)
  for (t in 1:n)
  {ndmr[t,]=r[t,]-t(rbar)
  
  }
  Shat=t(ndmr)%*%ndmr/n#sigmahat
###constants
icov=solve(sig)#var-cova of returns same as errors, precison matrix
ones=rep(1,p)
ones=matrix(ones,p,1)

A=t(ones)%*%icov%*%ones/p
B=t(ones)%*%icov%*%mu/p
D=t(mu)%*%icov%*%mu/p

w1=(D- rho1*B)/(A*D- B^2)
w1=matrix(w1,1,1)

w11=(icov%*%ones/p)%*%w1
w2=(rho1*A - B)/(A*D - B^2)
w2=matrix(w2,1,1)
w21=(icov%*%mu/p)%*%w2
ws=w11+w21#weight in markowitz
opv=(A*rho1^2-2*B*rho1+D)/(A*D-B^2)



###constants

#rcoef3 includes all nodewise regression results, each row is a result
rcoef3=matrix(0,p,p)# ignore the first column, keep the rest, each row is 
#gamma_j and p-1 elements
for (i in 1:p){  
  
  cvob3=glmnet(r[,-i],r[,i],alpha=1)
  
  
  nlambda=length(lambda1)
  nz=cvob3$df #no of nonzeros at each lambda  but df first value 
  #corresponds to lambda highest when u manually enter that
  nz=matrix(nz,nlambda,1)
  
  coef3=predict(cvob3,r[,-i],s=lambda1,type="coefficients")
  #gives auotomatic intercept, so use the last p-1 terms in p vector
  coef3=matrix(coef3,p,nlambda)
  
  rss=rep(0,nlambda)#find resid sum of squares for each lambda
  for (iij in 1:nlambda){
    rss[iij]=t(r[,i]-r[,-i]%*%coef3[2:(p),iij])%*%(r[,i]-r[,-i]%*%coef3[2:(p),iij])
  }
  nz1=sort(nz,decreasing=TRUE)#make the nonzeros correspond to lambda choices
  #largest nz should correspond to lowest lambda
  IC=matrix(0,nlambda,1)
  IC= log((rss/n))+(log(p)*nz1*log(log(n))/n)
  stepbic=which.min(IC)
  lambdaop=lambda1[stepbic,]#optimal lambda
  
  coeffnw=predict(cvob3,r[,-i],s=lambdaop,type="coefficients")
  coeffnw=matrix(coeffnw,p,1)
  
  
  rcoef3[,i]=-1*coeffnw
}
#now redesign rcoef3 so that it becomes C-hat matrix
# setup C-hat, p.1170 van de  geer etal 2015.
chat=matrix(1,p,p)
for (i in 1:p){
  chat[i,-i]=rcoef3[i,2:p]
  
}
sse=matrix(0,p,1)
pj=matrix(0,p,1)
tau2=diag(p)
for (j in 1:p){
  yy=r[,j]+(r[,-j]%*%rcoef3[j,2:p])#+ sign here since rcoef3 is -gammahat
  sse[j]=t(yy)%*%yy/n #sum of squared errors avgd
  rr=matrix(rcoef3[j,2:p],1,p-1)
  rr1=t(rr)
  rr1=abs(rr1)
  pj[j]=(1/2)*lambdaop*colSums(rr1)#sum of penalties, and lambdaop is divided by 2
  tau2[j,j]=(sse[j]+pj[j])^(-2)#tau2-hat^-2 matrix
  
}

thehat=tau2%*%chat#relaxed inverse matrix, eq(8) in van  de geer etal.

#check thms

Ahat=t(ones)%*%thehat%*%ones/p

Bhat=t(ones)%*%thehat%*%rbar/p
Dhat=t(rbar)%*%thehat%*%rbar/p
opvhat=(Ahat*rho1^2-2*Bhat*rho1+ Dhat)/(Ahat*Dhat-Bhat^2)

w1hat1=matrix(0,p,1)
w2hat2=matrix(0,p,1)
w1hat=matrix(0,1,1)
w2hat=matrix(0,1,1)
w1hat=(Dhat- rho1*Bhat)/(Ahat*Dhat- Bhat^2)
w1hat1=(thehat%*%ones/p)%*%w1hat
w2hat=(rho1*Ahat - Bhat)/(Ahat*Dhat - Bhat^2)
w2hat2=(thehat%*%rbar/p)%*%w2hat
wshat=w1hat1+w2hat2#weight in markowitz
aw=abs(wshat-ws)
l1e[jj]=colSums(aw)#li error markowitz
thm3er[jj]=abs(t(wshat)%*%(Shat-sig)%*%wshat)

err1[jj]=abs(opvhat/opv-1)
print(jj)
}



print("variance error")
print(mean(err1))#thm 1 error

print("l1 error of weights")
print(mean(l1e))#thm 2 error
print("thm 3 error:risk")
print(mean(thm3er))






