#SETUP factor STRUCTURE, FACTOR MODEL ESTIMATION BY POET
#Tables 3a-3b, POET
library(POET)
library(MASS)

n=100#sample size
p=0.5*n# of assets in portfolio

#GENERATE EXCESS ASSET RETURNS
r=matrix(0,n,p)
ite=100
ew1=matrix(0,ite,1)
error=matrix(0,ite,1)
thm3er1=matrix(0,ite,1)
for (jj in 1:ite){
  #dgp starts
  
  for (jjj in 1:n){
    muf=matrix(0,3,1)
    covf=diag(3)/10
    f=mvrnorm(1,muf,covf)
    f=matrix(f,3,1)#3-factors
    ##do this for each p, next steps to Get B factor loadings
    mub=matrix(0,3,1)
    covb=diag(3)/100
    b=matrix(0,p,3)#factor loadings
    for (i in 1:p){
      bi=mvrnorm(1,mub,covb)
      bi=matrix(bi,1,3)
      b[i,]=bi}
    
    cov=diag(p)#error covariance in factor model
    sig=b%*%covf%*%t(b)+cov#Sigma var cov matrix of returns, good for any i
    #so it stays
    #by (1.3) of Fan and Lv 2008, JOE
    mue=matrix(0,p,1)
    eps=mvrnorm(1,mue,cov)#p by 1 N(0, cov) where cov is gamma distributed
    ret=b%*%f+eps
    r[jjj,]=t(ret)
  }
  ###dgp is done
  icov=solve(sig)#precison matrix
  
  #generated
  ndmr=matrix(0,n,p)#nby p excess asset return demeaned
  #form sigmahat
  rbar=colMeans(r)#should be p by 1
  rbar=matrix(rbar,p,1)
  for (t in 1:n)
  {ndmr[t,]=r[t,]-t(rbar)
  
  }
  covY=POET(t(ndmr),7,0.5,"soft","vad")$SigmaY
  #covY are sample covariancematrix of returns by POET,0.5,SOFT,VAD ARE DEFAULTS, 
  #7 FACTORS ARE  RECOMMENDED BY POET PROGRAM,ALTERNATIVE IS ESTIMATE AND FIT
  invcov=solve(covY)#INVERSE MATRIX PRECISION ESTIMATE
  #SETUP CONSTANTS
  ones=rep(1,p)
  ones=matrix(ones,p,1)
  A=t(ones)%*%icov%*%ones
  w=(icov%*%ones)%*%A^(-1)
  #####
  
  
  Ahat=t(ones)%*%invcov%*%ones
  
  what=(invcov%*%ones)%*%Ahat^(-1)
  errorw1=abs(what-w)
  ew1[jj]=colSums(errorw1)
  
  thm3er[jj]=t(what)%*%(covY-sig)%*%what#thm 3 error
  thm3er1[jj]=abs(thm3er[jj])
  error[jj]=abs(Ahat/A-1)
print(jj)
  }
print("variance error")
print(mean(error))#thm 1 error

print("l1 error of weights")
print(mean(ew1))#thm 2 error
print("thm 3 error:risk")
print(mean(thm3er1))

  