#our JBES PAPER SIM, NODEWISE global min variance program, toeplitz,
#Tables 1a-b, Nodewise method
library(glmnet)
#library(matrix)
#SETUP TOEPLITZ STRUCTURE
rhoz=0.15#correlation
n=100#sample size
p=1.5*n# of assets in portfolio
omz=diag(p)#WILL FORM SIGMA
set.seed(10)
for(j in (1:p)){
  
  for (i in (1:p)){
    omz[i,j]=(rhoz)^{abs(i-j)}}
}
iomz=solve(omz)#very sparse, precision matrix, SIGMA^{-1} OR THETA

#GENERATE EXCESS ASSET RETURNS
ones=rep(1,p)
ones=matrix(ones,p,1)
A=t(ones)%*%iomz%*%ones
w=(iomz%*%ones)%*%A^(-1)

ite=100
error=matrix(0,ite,1)
ew1=matrix(0,ite,1)
thm3er=matrix(0,ite,1)

#now nodewise regression
#lambda choices
lambda1=c(10,20,30,40,50)#5 lambdas
lambda1=matrix(lambda1,length(lambda1),1)
  
for (jj in 1:ite){
print(jj)
rr11=rnorm(n*p)
rr11=matrix(rr11,n,p)
sqomz=chol(omz)
#t(sqomz)*sqomz=omz
r=rr11%*%sqomz#n by p
#generated
ndmr=matrix(0,n,p)
#form sigmahat
rbar=colMeans(r)#should be p by 1
rbar=matrix(rbar,p,1)
for (t in 1:n)
{ndmr[t,]=r[t,]-t(rbar)
  
}
Shat=t(ndmr)%*%ndmr/n#sigmahat


#rcoef3 includes all nodewise regression results, each row is a result
rcoef3=matrix(0,p,p)# ignore the first column, keep the rest, each row is 
#gamma_j and p-1 elements
for (i in 1:p){  
  
  cvob3=glmnet(r[,-i],r[,i],alpha=1)
  
  
  nlambda=length(lambda1)
  nz=cvob3$df #no of nonzeros at each lambda  but df first value 
  #corresponds to lambda highest when u manually enter that
  nz=matrix(nz,nlambda,1)
  
  coef3=predict(cvob3,r[,-i],s=lambda1,type="coefficients")
  #gives auotomatic intercept, so use the last p-1 terms in p vector
  coef3=matrix(coef3,p,nlambda)
  
  rss=rep(0,nlambda)#find resid sum of squares for each lambda
  for (iij in 1:nlambda){
    rss[iij]=t(r[,i]-r[,-i]%*%coef3[2:(p),iij])%*%(r[,i]-r[,-i]%*%coef3[2:(p),iij])
  }
  nz1=sort(nz,decreasing=TRUE)#make the nonzeros correspond to lambda choices
  #largest nz should correspond to lowest lambda
  IC=matrix(0,nlambda,1)
  IC= log((rss/n))+(log(p)*nz1*log(log(n))/n)
  stepbic=which.min(IC)
  lambdaop=lambda1[stepbic,]#optimal lambda
  
  coeffnw=predict(cvob3,r[,-i],s=lambdaop,type="coefficients")
  coeffnw=matrix(coeffnw,p,1)
  
  
  rcoef3[,i]=-1*coeffnw
}
#now redesign rcoef3 so that it becomes C-hat matrix
# setup C-hat, p.1170 van de  geer etal 2015.
chat=matrix(1,p,p)
for (i in 1:p){
  chat[i,-i]=rcoef3[i,2:p]
  
}
sse=matrix(0,p,1)
pj=matrix(0,p,1)
tau2=diag(p)
for (j in 1:p){
  yy=r[,j]+(r[,-j]%*%rcoef3[j,2:p])#+ sign here since rcoef3 is -gammahat
  sse[j]=t(yy)%*%yy/n #sum of squared errors avgd
  rr=matrix(rcoef3[j,2:p],1,p-1)
  rr1=t(rr)
  rr1=abs(rr1)
  pj[j]=(1/2)*lambdaop*colSums(rr1)#sum of penalties, and lambdaop is divided by 2
  tau2[j,j]=(sse[j]+pj[j])^(-2)#tau2-hat^-2 matrix
  
}

thehat=tau2%*%chat#relaxed inverse matrix, eq(8) in van  de geer etal.

#check thm 3.1

Ahat=t(ones)%*%thehat%*%ones

what=(thehat%*%ones)%*%Ahat^(-1)
errorw1=abs(what-w)
ew1[jj]=colSums(errorw1)

thm3er[jj]=t(what)%*%(Shat-omz)%*%what#thm 3 error
thm3er[jj]=abs(thm3er[jj])
error[jj]=abs(Ahat/A-1)

}

print("variance error")
print(mean(error))#thm 1 error

print("l1 error of weights")
print(mean(ew1))#thm 2 error
print("thm 3 error:risk")
print(mean(thm3er))

